﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;
using Microsoft.Win32;
using MindFusion.Diagramming.Wpf;

namespace EventLogger
{
	/// <summary>
	/// Interaction logic for Window1.xaml
	/// </summary>
	public partial class Window1 : Window
	{
		public Window1()
		{
			InitializeComponent();

			var mainNode = diagram1.Factory.CreateShapeNode(50, 50, 200, 200);
			var subNode = diagram1.Factory.CreateShapeNode(80, 80, 40, 40);
			subNode.Locked = true;
			subNode.AttachTo(mainNode, AttachToNode.TopLeft);

			//diagram1.Behavior = Behavior.Modify;
		}


		private void diagram1_ActionRecorded(object sender, MindFusion.Diagramming.Wpf.UndoEventArgs e)
		{
			Log("Diagram.ActionRecorded");
		}

		private void diagram1_ActionRecording(object sender, MindFusion.Diagramming.Wpf.UndoValidationEventArgs e)
		{
			Log("Diagram.ActionRecording");
		}

		private void diagram1_ActionRedone(object sender, MindFusion.Diagramming.Wpf.UndoEventArgs e)
		{
			Log("Diagram.ActionRedone");
		}

		private void diagram1_ActionUndone(object sender, MindFusion.Diagramming.Wpf.UndoEventArgs e)
		{
			Log("Diagram.ActionUndone");
		}

		private void diagram1_BeginLoad(object sender, EventArgs e)
		{
			Log("Diagram.BeginLoad");
		}

		private void diagram1_BoundsChanged(object sender, EventArgs e)
		{
			Log("Diagram.BoundsChanged");
		}

		private void diagram1_CellClicked(object sender, MindFusion.Diagramming.Wpf.CellEventArgs e)
		{
			Log("Diagram.CellClicked");
		}

		private void diagram1_CellDoubleClicked(object sender, MindFusion.Diagramming.Wpf.CellEventArgs e)
		{
			Log("Diagram.CellDoubleClicked");
		}

		private void diagram1_CellTextEdited(object sender, MindFusion.Diagramming.Wpf.EditCellTextEventArgs e)
		{
			Log("Diagram.CellTextEdited");
		}

		private void diagram1_CellTextEditing(object sender, MindFusion.Diagramming.Wpf.CellValidationEventArgs e)
		{
			Log("Diagram.CellTextEditing");
		}

		private void diagram1_Clicked(object sender, MindFusion.Diagramming.Wpf.DiagramEventArgs e)
		{
			if (checkBox1.IsChecked == true)
				Log("Diagram.Clicked");
		}

		private void diagram1_ContainerChildAdded(object sender, MindFusion.Diagramming.Wpf.ContainerChildEventArgs e)
		{
			Log("Diagram.ContainerChildAdded");
		}

		private void diagram1_ContainerChildRemoved(object sender, MindFusion.Diagramming.Wpf.ContainerChildEventArgs e)
		{
			Log("Diagram.ContainerChildRemoved");
		}

		private void diagram1_ContainerFolded(object sender, MindFusion.Diagramming.Wpf.NodeEventArgs e)
		{
			Log("Diagram.ContainerFolded");
		}

		private void diagram1_ContainerUnfolded(object sender, MindFusion.Diagramming.Wpf.NodeEventArgs e)
		{
			Log("Diagram.ContainerUnfolded");
		}

		private void diagram1_DefaultShapeChanged(object sender, EventArgs e)
		{
			Log("Diagram.DefaultShapeChanged");
		}

		private void diagram1_DeserializeTag(object sender, MindFusion.Diagramming.Wpf.SerializeTagEventArgs e)
		{
			Log("Diagram.DeserializeTag");
		}

		private void diagram1_DestinationAnchorChanged(object sender, MindFusion.Diagramming.Wpf.AnchorPointEventArgs e)
		{
			Log("Diagram.DestinationAnchorChanged");
		}

		private void diagram1_DirtyChanged(object sender, EventArgs e)
		{
			Log("Diagram.DirtyChanged");
		}

		private void diagram1_DoubleClicked(object sender, MindFusion.Diagramming.Wpf.DiagramEventArgs e)
		{
			if (checkBox1.IsChecked == true)
				Log("Diagram.DoubleClicked");
		}

		private void diagram1_DrawAdjustmentHandles(object sender, MindFusion.Diagramming.Wpf.DrawItemEventArgs e)
		{
			if (checkBox2.IsChecked == true)
				Log("Diagram.DrawAdjustmentHandles");
		}

		private void diagram1_DrawAnchorPoint(object sender, MindFusion.Diagramming.Wpf.DrawAnchorPointEventArgs e)
		{
			if (checkBox2.IsChecked == true)
				Log("Diagram.DrawAnchorPoint");
		}

		private void diagram1_DrawCell(object sender, MindFusion.Diagramming.Wpf.DrawCellEventArgs e)
		{
			if (checkBox2.IsChecked == true)
				Log("Diagram.DrawCell");
		}

		private void diagram1_DrawLaneHeader(object sender, MindFusion.Diagramming.Wpf.Lanes.DrawHeaderEventArgs e)
		{
			Log("Diagram.DrawLaneHeader");
		}

		private void diagram1_DrawLink(object sender, MindFusion.Diagramming.Wpf.DrawLinkEventArgs e)
		{
			if (checkBox2.IsChecked == true)
				Log("Diagram.DrawLink");
		}

		private void diagram1_DrawNode(object sender, MindFusion.Diagramming.Wpf.DrawNodeEventArgs e)
		{
			if (checkBox2.IsChecked == true)
				Log("Diagram.DrawNode");
		}

		private void diagram1_EndLoad(object sender, EventArgs e)
		{
			Log("Diagram.EndLoad");
		}

		private void diagram1_EnterInplaceEditMode(object sender, MindFusion.Diagramming.Wpf.InPlaceEditEventArgs e)
		{
			Log("Diagram.EnterInplaceEditMode");
		}

		private void diagram1_ExpandButtonClicked(object sender, MindFusion.Diagramming.Wpf.NodeEventArgs e)
		{
			Log("Diagram.ExpandButtonClicked");
		}

		private void diagram1_GroupDestroyed(object sender, MindFusion.Diagramming.Wpf.GroupEventArgs e)
		{
			Log("Diagram.GroupDestroyed");
		}

		private void diagram1_HitTestAdjustmentHandles(object sender, MindFusion.Diagramming.Wpf.HitTestEventArgs e)
		{
			Log("Diagram.HitTestAdjustmentHandles");
		}

		private void diagram1_InitializeLink(object sender, MindFusion.Diagramming.Wpf.LinkEventArgs e)
		{
			Log("Diagram.InitializeLink");
		}

		private void diagram1_InitializeNode(object sender, MindFusion.Diagramming.Wpf.NodeEventArgs e)
		{
			Log("Diagram.InitializeNode");
		}

		private void diagram1_ItemAdded(object sender, MindFusion.Diagramming.Wpf.ItemEventArgs e)
		{
			Log("Diagram.ItemAdded");
		}

		private void diagram1_ItemRemoved(object sender, MindFusion.Diagramming.Wpf.ItemEventArgs e)
		{
			Log("Diagram.ItemRemoved");
		}

		private void diagram1_LeaveInplaceEditMode(object sender, MindFusion.Diagramming.Wpf.InPlaceEditEventArgs e)
		{
			Log("Diagram.LeaveInplaceEditMode");
		}

		private void diagram1_LinkActivated(object sender, MindFusion.Diagramming.Wpf.LinkEventArgs e)
		{
			Log("Diagram.LinkActivated");
		}

		private void diagram1_LinkClicked(object sender, MindFusion.Diagramming.Wpf.LinkEventArgs e)
		{
			Log("Diagram.LinkClicked");
		}

		private void diagram1_LinkCreated(object sender, MindFusion.Diagramming.Wpf.LinkEventArgs e)
		{
			Log("Diagram.LinkCreated");
		}

		private void diagram1_LinkCreating(object sender, MindFusion.Diagramming.Wpf.LinkValidationEventArgs e)
		{
			Log("Diagram.LinkCreating");
		}

		private void diagram1_LinkDeactivated(object sender, MindFusion.Diagramming.Wpf.LinkEventArgs e)
		{
			Log("Diagram.LinkDeactivated");
		}

		private void diagram1_LinkDeleted(object sender, MindFusion.Diagramming.Wpf.LinkEventArgs e)
		{
			Log("Diagram.LinkDeleted");
		}

		private void diagram1_LinkDeleting(object sender, MindFusion.Diagramming.Wpf.LinkValidationEventArgs e)
		{
			Log("Diagram.LinkDeleting");
		}

		private void diagram1_LinkDeselected(object sender, MindFusion.Diagramming.Wpf.LinkEventArgs e)
		{
			Log("Diagram.LinkDeselected");
		}

		private void diagram1_LinkDoubleClicked(object sender, MindFusion.Diagramming.Wpf.LinkEventArgs e)
		{
			Log("Diagram.LinkDoubleClicked");
		}

		private void diagram1_LinkModified(object sender, MindFusion.Diagramming.Wpf.LinkEventArgs e)
		{
			Log("Diagram.LinkModified");
		}

		private void diagram1_LinkModifying(object sender, MindFusion.Diagramming.Wpf.LinkValidationEventArgs e)
		{
			Log("Diagram.LinkModifying");
		}

		private void diagram1_LinkPasted(object sender, MindFusion.Diagramming.Wpf.LinkEventArgs e)
		{
			Log("Diagram.LinkPasted");
		}

		private void diagram1_LinkRouted(object sender, MindFusion.Diagramming.Wpf.LinkEventArgs e)
		{
			Log("Diagram.LinkRouted");
		}

		private void diagram1_LinkSelected(object sender, MindFusion.Diagramming.Wpf.LinkEventArgs e)
		{
			Log("Diagram.LinkSelected");
		}

		private void diagram1_LinkSelecting(object sender, MindFusion.Diagramming.Wpf.LinkValidationEventArgs e)
		{
			Log("Diagram.LinkSelecting");
		}

		private void diagram1_LinkStartModifying(object sender, MindFusion.Diagramming.Wpf.LinkValidationEventArgs e)
		{
			Log("Diagram.LinkStartModifying");
		}

		private void diagram1_LinkTextEdited(object sender, MindFusion.Diagramming.Wpf.EditLinkTextEventArgs e)
		{
			Log("Diagram.LinkTextEdited");
		}

		private void diagram1_LinkTextEditing(object sender, MindFusion.Diagramming.Wpf.LinkValidationEventArgs e)
		{
			Log("Diagram.LinkTextEditing");
		}

		private void diagram1_MeasureUnitChanged(object sender, EventArgs e)
		{
			Log("Diagram.MeasureUnitChanged");
		}

		private void diagram1_MouseDoubleClick(object sender, MouseButtonEventArgs e)
		{
			if (checkBox1.IsChecked == true)
				Log("Diagram.MouseDoubleClick");
		}

		private void diagram1_MouseDown(object sender, MouseButtonEventArgs e)
		{
			if (checkBox1.IsChecked == true)
				Log("Diagram.MouseDown");
		}

		private void diagram1_MouseEnter(object sender, MouseEventArgs e)
		{
			if (checkBox1.IsChecked == true)
				Log("Diagram.MouseEnter");
		}

		private void diagram1_MouseLeave(object sender, MouseEventArgs e)
		{
			if (checkBox1.IsChecked == true)
				Log("Diagram.MouseLeave");
		}

		private void diagram1_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
		{
			if (checkBox1.IsChecked == true)
				Log("Diagram.MouseLeftButtonDown");
		}

		private void diagram1_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
		{
			if (checkBox1.IsChecked == true)
				Log("Diagram.MouseLeftButtonUp");
		}

		private void diagram1_MouseMove(object sender, MouseEventArgs e)
		{
			if (checkBox1.IsChecked == true)
				Log("Diagram.MouseMove");
		}

		private void diagram1_MouseRightButtonDown(object sender, MouseButtonEventArgs e)
		{
			if (checkBox1.IsChecked == true)
				Log("Diagram.MouseRightButtonDown");
		}

		private void diagram1_MouseRightButtonUp(object sender, MouseButtonEventArgs e)
		{
			if (checkBox1.IsChecked == true)
				Log("Diagram.MouseRightButtonUp");
		}

		private void diagram1_MouseUp(object sender, MouseButtonEventArgs e)
		{
			if (checkBox1.IsChecked == true)
				Log("Diagram.MouseUp");
		}

		private void diagram1_MouseWheel(object sender, MouseWheelEventArgs e)
		{
			if (checkBox1.IsChecked == true)
				Log("Diagram.MouseWheel");
		}

		private void diagram1_NodeActivated(object sender, MindFusion.Diagramming.Wpf.NodeEventArgs e)
		{
			Log("Diagram.NodeActivated");
		}

		private void diagram1_NodeClicked(object sender, MindFusion.Diagramming.Wpf.NodeEventArgs e)
		{
			Log("Diagram.NodeClicked");
		}

		private void diagram1_NodeCreated(object sender, MindFusion.Diagramming.Wpf.NodeEventArgs e)
		{
			Log("Diagram.NodeCreated");
		}

		private void diagram1_NodeCreating(object sender, MindFusion.Diagramming.Wpf.NodeValidationEventArgs e)
		{
			Log("Diagram.NodeCreating");
		}

		private void diagram1_NodeDeactivated(object sender, MindFusion.Diagramming.Wpf.NodeEventArgs e)
		{
			Log("Diagram.NodeDeactivated");
		}

		private void diagram1_NodeDeleted(object sender, MindFusion.Diagramming.Wpf.NodeEventArgs e)
		{
			Log("Diagram.NodeDeleted");
		}

		private void diagram1_NodeDeleting(object sender, MindFusion.Diagramming.Wpf.NodeValidationEventArgs e)
		{
			Log("Diagram.NodeDeleting");
		}

		private void diagram1_NodeDeselected(object sender, MindFusion.Diagramming.Wpf.NodeEventArgs e)
		{
			Log("Diagram.NodeDeselected");
		}

		private void diagram1_NodeDoubleClicked(object sender, MindFusion.Diagramming.Wpf.NodeEventArgs e)
		{
			Log("Diagram.NodeDoubleClicked");
		}

		private void diagram1_NodeModified(object sender, MindFusion.Diagramming.Wpf.NodeEventArgs e)
		{
			Log("Diagram.NodeModified");
		}

		private void diagram1_NodeModifying(object sender, MindFusion.Diagramming.Wpf.NodeValidationEventArgs e)
		{
			Log("Diagram.NodeModifying");
		}

		private void diagram1_NodePasted(object sender, MindFusion.Diagramming.Wpf.NodeEventArgs e)
		{
			Log("Diagram.NodePasted");
		}

		private void diagram1_NodeSelected(object sender, MindFusion.Diagramming.Wpf.NodeEventArgs e)
		{
			Log("Diagram.NodeSelected");
		}

		private void diagram1_NodeSelecting(object sender, MindFusion.Diagramming.Wpf.NodeValidationEventArgs e)
		{
			Log("Diagram.NodeSelecting");
		}

		private void diagram1_NodeStartModifying(object sender, MindFusion.Diagramming.Wpf.NodeValidationEventArgs e)
		{
			Log("Diagram.NodeStartModifying");
		}

		private void diagram1_NodeTextEdited(object sender, MindFusion.Diagramming.Wpf.EditNodeTextEventArgs e)
		{
			Log("Diagram.NodeTextEdited");
		}

		private void diagram1_NodeTextEditing(object sender, MindFusion.Diagramming.Wpf.NodeValidationEventArgs e)
		{
			Log("Diagram.NodeTextEditing");
		}

		private void diagram1_OriginAnchorChanged(object sender, MindFusion.Diagramming.Wpf.AnchorPointEventArgs e)
		{
			Log("Diagram.OriginAnchorChanged");
		}

		private void diagram1_SelectionChanged(object sender, EventArgs e)
		{
			Log("Diagram.SelectionChanged");
		}

		private void diagram1_SelectionMoved(object sender, EventArgs e)
		{
			Log("Diagram.SelectionMoved");
		}

		private void diagram1_SelectionMoving(object sender, MindFusion.Diagramming.Wpf.ValidationEventArgs e)
		{
			Log("Diagram.SelectionMoving");
		}

		private void diagram1_SerializeTag(object sender, MindFusion.Diagramming.Wpf.SerializeTagEventArgs e)
		{
			Log("Diagram.SerializeTag");
		}

		private void diagram1_TableSectionCollapsed(object sender, MindFusion.Diagramming.Wpf.RowEventArgs e)
		{
			Log("Diagram.TableSectionCollapsed");
		}

		private void diagram1_TableSectionExpanded(object sender, MindFusion.Diagramming.Wpf.RowEventArgs e)
		{
			Log("Diagram.TableSectionExpanded");
		}		

		private void diagram1_TreeCollapsed(object sender, MindFusion.Diagramming.Wpf.NodeEventArgs e)
		{
			Log("Diagram.TreeCollapsed");
		}

		private void diagram1_TreeExpanded(object sender, MindFusion.Diagramming.Wpf.NodeEventArgs e)
		{
			Log("Diagram.TreeExpanded");
		}

		private void diagram1_TreeItemTextEditing(object sender, MindFusion.Diagramming.Wpf.TreeItemValidationEventArgs e)
		{
			Log("Diagram.TreeItemTextEditing");
		}

		private void diagram1_ValidateAnchorPoint(object sender, MindFusion.Diagramming.Wpf.LinkValidationEventArgs e)
		{
			Log("Diagram.ValidateAnchorPoint");
		}

		private void diagram1_ZoomFactorChanged(object sender, EventArgs e)
		{
			Log("Diagram.ZoomFactorChanged");
		}

		private void Log(string message)
		{
			ListBoxItem item = new ListBoxItem();
			item.Content = message;
			listBox1.Items.Add(item);
			listBox1.ScrollIntoView(item);
		}

		private void button1_Click(object sender, RoutedEventArgs e)
		{
			listBox1.Items.Clear();
		}

		private void button2_Click(object sender, RoutedEventArgs e)
		{
			OpenFileDialog d = new OpenFileDialog();
			if (d.ShowDialog() == true)
			{
				try
				{
					diagram1.LoadFromString(d.FileName);
				}
				catch
				{
				}
			}
		}

		private void button3_Click(object sender, RoutedEventArgs e)
		{
			OpenFileDialog d = new OpenFileDialog();
			if (d.ShowDialog() == true)
			{
				try
				{
					diagram1.LoadFromXml(d.FileName);
				}
				catch
				{
				}
			}
		}

		private void diagram1_PreviewKeyUp(object sender, KeyEventArgs e)
		{
			Log("Diagram.PreviewKeyUp");
		}	
	}
}
